unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLVectorFileObjects, Menus, GLObjects, GLCoordinates,
  GLCrossPlatform, BaseClasses, GLWin32Viewer,
  GLFile3DS, ComCtrls, GLState ;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    MainMenu1: TMainMenu;
    Archivos1: TMenuItem;
    Abrir1: TMenuItem;
    N1: TMenuItem;
    Salir1: TMenuItem;
    GLFreeForm1: TGLFreeForm;
    OpenDialog1: TOpenDialog;
    GLLightSource2: TGLLightSource;
    StatusBar1: TStatusBar;
    Aspecto1: TMenuItem;
    Solido1: TMenuItem;
    Malla1: TMenuItem;
    Puntos1: TMenuItem;
    procedure Abrir1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Solido1Click(Sender: TObject);
    procedure Malla1Click(Sender: TObject);
    procedure Puntos1Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
    ss    : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := 1.0;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.05;
  if ss<0.2 then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.05;
  if ss>8 then ss := 8;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
var
  RC        : single;
  xc,yc,zc  : single;

  nom : string;
  NP  : integer;
begin
  OpenDialog1.InitialDir := '.';
  OPenDialog1.Filter := 'Archivo 3DS|*.3ds|Todos|*.*';

  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;

    GLFreeForm1.LoadFromFile(nom);
    RC := GLFreeForm1.BoundingSphereRadius;
    StatusBar1.Panels[1].Text := FloatToStrF(RC,ffFixed,8,5);

    if (RC > 0) then
      GLFreeForm1.Scale.Scale(1/RC);

    xc := GLFreeForm1.BarycenterAbsolutePosition[0];
    yc := GLFreeForm1.BarycenterAbsolutePosition[1];
    zc := GLFreeForm1.BarycenterAbsolutePosition[2];
    StatusBar1.Panels[3].Text := FloatToStrF(xc,ffFixed,8,5);
    StatusBar1.Panels[4].Text := FloatToStrF(yc,ffFixed,8,5);
    StatusBar1.Panels[5].Text := FloatToStrF(zc,ffFixed,8,5);
    GLFreeForm1.Translate(-xc,-yc,-zc);

    NP := GLFreeForm1.MeshObjects.TriangleCount;
    StatusBar1.Panels[7].Text := IntToStr(NP);

  end;
end;

procedure TForm1.Solido1Click(Sender: TObject);
begin
  GLFreeForm1.Material.PolygonMode := pmFill;
end;

procedure TForm1.Malla1Click(Sender: TObject);
begin
  GLFreeForm1.Material.PolygonMode := pmLines;
end;

procedure TForm1.Puntos1Click(Sender: TObject);
begin
  GLFreeForm1.Material.PolygonMode := pmPoints;
end;


end.
